# ****************************************************************************
# TE0820- TE0701- FMC - Imageon IIC
# ****************************************************************************
set_property PACKAGE_PIN F7 [get_ports im_i2c_scl_io]
set_property PACKAGE_PIN G8 [get_ports im_i2c_sda_io]

set_property IOSTANDARD LVCMOS18 [get_ports im_i2c_*]
set_property SLEW SLOW [get_ports im_i2c_*]
set_property DRIVE 8 [get_ports im_i2c_*]

set_property PACKAGE_PIN C4 [get_ports {im_resetn[0]}]
set_property IOSTANDARD LVCMOS18 [get_ports {im_resetn[0]}]
set_property SLEW SLOW [get_ports {im_resetn[0]}]
set_property DRIVE 8 [get_ports {im_resetn[0]}]

# ****************************************************************************
# TE0820-- TE0701- FMC - Imageon HDMII (ADV7611)
# ****************************************************************************
set_property PACKAGE_PIN AD7   [get_ports {hdmii[15]}]
set_property PACKAGE_PIN AE7   [get_ports {hdmii[14]}]
set_property PACKAGE_PIN AH7  [get_ports {hdmii[13]}]
set_property PACKAGE_PIN AH8  [get_ports {hdmii[12]}]
set_property PACKAGE_PIN AG8  [get_ports {hdmii[11]}]
set_property PACKAGE_PIN AF8  [get_ports {hdmii[10]}]
set_property PACKAGE_PIN AH9  [get_ports {hdmii[9]}]
set_property PACKAGE_PIN AG9  [get_ports {hdmii[8]}]
set_property PACKAGE_PIN AG6  [get_ports {hdmii[7]}]
set_property PACKAGE_PIN AE2  [get_ports {hdmii[6]}]
set_property PACKAGE_PIN AC6   [get_ports {hdmii[5]}]
set_property PACKAGE_PIN AG5  [get_ports {hdmii[4]}]
set_property PACKAGE_PIN AF2  [get_ports {hdmii[3]}]
set_property PACKAGE_PIN AB6   [get_ports {hdmii[2]}]
set_property PACKAGE_PIN AC7   [get_ports {hdmii[1]}]
set_property PACKAGE_PIN AB7   [get_ports {hdmii[0]}]

# set_property PACKAGE_PIN U6   [get_ports hdmii_spdif]

set_property PACKAGE_PIN D7  [get_ports hdmii_clk]

set_property IOSTANDARD LVCMOS18 [get_ports hdmii[*]]
set_property IOSTANDARD LVCMOS18 [get_ports hdmii_clk]

create_clock -period 6.666 -name hdmii_clk -waveform {0.000 3.333} -add [get_ports hdmii_clk]

# ****************************************************************************
# TE0820- - TE0701- FMC - Imageon HDMIO (ADV7511)
# ****************************************************************************
set_property PACKAGE_PIN AB2 [get_ports {hdmio[15]}]
set_property PACKAGE_PIN AD5   [get_ports {hdmio[14]}]
set_property PACKAGE_PIN AC2 [get_ports {hdmio[13]}]
set_property PACKAGE_PIN AD2   [get_ports {hdmio[12]}]
set_property PACKAGE_PIN AD4   [get_ports {hdmio[11]}]
set_property PACKAGE_PIN AC4  [get_ports {hdmio[10]}]
set_property PACKAGE_PIN AD1  [get_ports {hdmio[9]}]
set_property PACKAGE_PIN AE3  [get_ports {hdmio[8]}]
set_property PACKAGE_PIN AB1 [get_ports {hdmio[7]}]
set_property PACKAGE_PIN AC3  [get_ports {hdmio[6]}]
set_property PACKAGE_PIN AF3  [get_ports {hdmio[5]}]
set_property PACKAGE_PIN AG4  [get_ports {hdmio[4]}]
set_property PACKAGE_PIN AC1  [get_ports {hdmio[3]}]
set_property PACKAGE_PIN AH4  [get_ports {hdmio[2]}]
set_property PACKAGE_PIN AG3  [get_ports {hdmio[1]}]
set_property PACKAGE_PIN AH3   [get_ports {hdmio[0]}]

# set_property PACKAGE_PIN U5   [get_ports hdmio_spdif]

set_property PACKAGE_PIN D6  [get_ports im_hdmio_clk]

set_property IOSTANDARD LVCMOS18 [get_ports hdmio[*]]
set_property IOSTANDARD LVCMOS18 [get_ports im_hdmio_clk]

create_clock -period 6.666 -name im_hdmio_clk -waveform {0.000 3.333} -add [get_ports im_hdmio_clk]

