/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 08 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 * contact: sp@utia.cz
 *
 * Filename: dt_fb.h
 *
 * Date: 03.12.2018
 * Author: Lukas Kohout <kohoutl@utia.cas.cz>
 * Description:
 *      get user frame buffer parameters from devicetree 
 *
 * Changelog:
 *
 *
 *
 *
 ********************************************/


#ifndef _DT_FB_HEADER_FILE_
#define _DT_FB_HEADER_FILE_


#define DT_FB_ERR_1     0x000000001
#define DT_FB_ERR_2     0x000000002
#define DT_FB_ERR_3     0x000000004
#define DT_FB_ERR_4     0x000000008
#define DT_FB_ERR_5     0x000000010
#define DT_FB_ERR_6     0x000000020
#define DT_FB_ERR_7     0x000000040
#define DT_FB_ERR_8     0x000000080
#define DT_FB_ERR_9     0x000000100
#define DT_FB_ERR_10    0x000000200
#define DT_FB_ERR_11    0x000000400
#define DT_FB_ERR_12    0x000000800

struct struct_dt_fb_params
{
    unsigned int cells;
    unsigned int cells_size;
    unsigned int base_high;
    unsigned int base_low;
    unsigned int size_high;
    unsigned int size_low;
    unsigned int width;
    unsigned int height;
    unsigned int stride;
};
typedef struct struct_dt_fb_params dt_fb_params_t;


unsigned int get_dt_fb_params( char *device_path, dt_fb_params_t *params );
void print_dt_fb_params( dt_fb_params_t *params );


#endif