/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 08 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 * contact: sp@utia.cz
 *
 * Filename: utia_handoff.c
 * Date: 19.11.2018
 * Author: Lukas Kohout <kohoutl@utia.cas.cz>
 * Description:
 *    Trenz TE0701-05 HDMI OUT (ADV7511) interface
 *
 * Changelog:
 *
 *
 *
 *
 ********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <xparameters.h>
#include <xil_types.h>
#include <xil_cache.h>
#include <xfsbl_error.h>

#include "xil_printf.h"

#include "utia_handoff.h"
#include "adv7511_te.h"
// #include "vdma.h"


u32 utia_handoff( void )
{
    u32 status = XFSBL_SUCCESS;

    xil_printf("UTIA HandOff ... \n\r");

    xil_printf("  FSBL: Initialize I2C controller for HDMI OUT - ADV7511 ... " );
    status = adv7511_te_i2c_init(XPAR_AXI_IIC_0_HO_BASEADDR);
    if ( status != XFSBL_SUCCESS) {
        xil_printf("FAILED\n\r");
        goto END_ERR;
    } else {
        xil_printf("OK\n\r");
    }
    

    /*
     * Initialize HDMI Output - ADV 7511 on TE0701-05 carrier - 1920x1080p60
     */
    xil_printf("  FSBL: Initialize HDMI OUT - ADV7511 ... " );
    status = adv7511_te_init(XPAR_AXI_IIC_0_HO_BASEADDR, ADV7511_TE_CLK_DELAY_NEG_0_8_NS, ADV7511_TE_HPD_TEST_DISABLED);
    if ( status != XFSBL_SUCCESS ) {
        xil_printf("FAILED\n\r");
        goto END_ERR;
    } else {
        xil_printf("OK\n\r");
    }

    
//     /*
//      * Initialize VDMA
//      */
//     xil_printf("  FSBL: VDMA Common init ... ");
//     status = vdma_common_init( XPAR_VDMA_AXI_VDMA_0_DEVICE_ID );
//     if ( status != XFSBL_SUCCESS ) {
//         xil_printf("FAILED\n\r");
//         goto END_ERR;
//     } else {
//         xil_printf("OK\n\r");
//     }
// 
//     /*
//         * Configure VDMA Output to 1080p
//         */
//     xil_printf("  FSBL: Set VDMA out to 1080p ... ");
//     status = vdma_out_init(HDMI_FB_ADDR, 1920, 1080, 4);
//     if ( status != XFSBL_SUCCESS ) {
//         xil_printf("FAILED\n\r");
//         goto END_ERR;
//     } else {
//         xil_printf("OK\n\r");
//     }

    xil_printf("Done\n\r\n\r");

    while ( !XUartPs_IsTxEmpty(STDOUT_BASEADDRESS) ) {}

    return XFSBL_SUCCESS;
    
END_ERR:
    xil_printf("FAILED\n\r\n\r");
    while ( !XUartPs_IsTxEmpty(STDOUT_BASEADDRESS) ) {}
    return status;
}


